CnM.events = {};

function CnM.events.OnLoad( this )
	this:RegisterForClicks( "LeftButton", "RightButton" );
	
	this:RegisterEvent("VARIABLES_LOADED");
end;

function CnM.events.OnEvent( this, event )
	if( event == "VARIABLES_LOADED" )then
		CnM.events.VariablesLoaded();
	end;
end;

function CnM.events.VariablesLoaded()
	local hRet;
	hRet, CnMVariables = MLib.CheckVariables( CnMVariables, CnM.DefaultConfig );
	if( hRet == MLIB_CHECKVARIABLES_FAILED )then
		CnM.Message( "|cffFF0000Ошибка запуска! Исполнение прекращено!|r" );
		CnM.PANIC = true;
		return nil;
	end;
	if( hRet == MLIB_CHECKVARIABLES_FIRSTSTART )then
		CnM.Message( "Первый запуск! Установка параметров по умолчанию." );
	end;
	SaveVariables("CnMVariables");
	
	CnM.Message( CnM.Name .. " " .. CnM.Version .. " загружен успешно" );
end;

function CnM.events.MinimapOnClick( this, key )
	if( key == "LBUTTON" )and( not MLib.ControlsDown( false, false, false ) )then
		local _frame = _G["CnMMainFrame"];
		if( _frame:IsVisible() )then
			_frame:Hide();
		else
			_frame:Show();
		end;
	end;
end;

function CnM.events.MinimapOnEnter( this )
	MLib.TT.Init( this, CnM.Name .. " " .. CnM.Version, 300, "ANCHOR_TOPLEFT", 0, 0 );
	MLib.TT.Space();
	MLib.TT.Line( "Левая кнопка мыши показать окно настроек" );
	MLib.TT.Space();
	MLib.TT.Line( UI_MINIMAPBUTTON_MOVE, 0, 0.75, 0.95 );
end;

function CnM.events.OnShow( this )
	local name = this:GetName();
	_G[ name .. "Title" ]:SetText( CnM.Name .. " v." .. CnM.Version );
	_G[ name .. "lbl1" ].Caption = "Список подключенных каналов:";

	local cn, _temp = {}, { GetChannelList() };
	for n = 1, #_temp, 2 do
		if( _temp[ n + 1 ] ~= nil )then
			local color = ChannelChange_Color[ _temp[ n ] ];
			local pattern = MLib.ColorDec2Hex( color.r, color.g, color.b ) .. "%s|r";
			if( color.r == 1 )and( color.g == 1 )and( color.b == 1 )then pattern = "|cFF00f9f9%s|r"; end;
			
			if( GetChannelOwner( _temp[ n + 1 ] ) == UnitName( "player" ) )then pattern = pattern .. " |cFF990101*|r"; end;
			
			cn[ #cn + 1 ] = pattern:format( _temp[ n + 1 ] );
		end;
	end;
	_G[ name .. "Channels" ].Items = cn;
end;

--[[ /run dofile("interface/addons/mChannelManager/code/events.lua"); ]]